/* : usbdrvasm15.inc
 * : AVR USB driver
 * :  V. Bosch
 * : microsin.ru 
 *  : 2007-08-06
 * : 4
 * Copyright: (c) 2007 by OBJECTIVE DEVELOPMENT Software GmbH
 * : GNU GPL v2 (. License.txt)   (CommercialLicense.txt)
 * : $Id: usbdrvasm15.inc 607 2008-05-13 15:57:28Z cs $
 */

/*    !    usbdrvasm.S,   include
 *      (   )!
 */

/*
 :
   15      USB.  
 15  (      RC-).

. usbdrv.h    .

       ,   ,  
  ,  !      
  CPU,     !
*/

;  : [ret(2), YL, SREG, YH, bitcnt, shift, x1, x2, x3, x4, cnt] = 12 
; : 15  -> 10.0   , 80.0   
;      ,      sync
;   

;----------------------------------------------------------------------------
;   : 
;	YL, SREG [sofError] YH, shift, x1, x2, x3, bitcnt, cnt, x4
;----------------------------------------------------------------------------
USB_INTR_VECTOR:              
    push    YL                   ;2 	push    .   ASAP
    in      YL, SREG             ;1 
    push    YL                   ;2 
;----------------------------------------------------------------------------
;    sync:
;
;    sync- (D-)   (LSb)   (MSb) : 01010100 [1 =  (idle) = J, 0 = K]
;   sync  J   K    sync --    
;       ,    IDLE  SE1 (== )
;-------------------------------------------------------------------------------
waitForJ:			 ;- 
    sbis    USBIN, USBMINUS		;1 <-- : ,  D- == 1
    rjmp    waitForJ			;2 
;-------------------------------------------------------------------------------
; C      1/4 ,   .
;-------------------------------------------------------------------------------
waitForK:			 ;- 
    sbis    USBIN, USBMINUS      ;1 [00] <-- 
    rjmp    foundK               ;2 [01]
    sbis    USBIN, USBMINUS	     ;	 <-- 
    rjmp    foundK
    sbis    USBIN, USBMINUS	     ;	 <-- 
    rjmp    foundK
    sbis    USBIN, USBMINUS	     ;	 <-- 
    rjmp    foundK
    sbis    USBIN, USBMINUS	     ;	 <-- 
    rjmp    foundK
    sbis    USBIN, USBMINUS	     ;	 <-- 
    rjmp    foundK
#if USB_COUNT_SOF
    lds     YL, usbSofCount
    inc     YL
    sts     usbSofCount, YL
#endif  /* USB_COUNT_SOF */
    rjmp    sofError
;------------------------------------------------------------------------------
; {3, 5}    D-  : 4  [  5   ]
;      1  ,   setup,    
;   .    -     sync ( K)  
;    
;------------------------------------------------------------------------------
foundK:                          ;- [02]
    lds     YL, usbInputBufOffset;2 [03+04]	 tx
    push    YH                   ;2 [05+06]
    clr     YH                   ;1 [07]
    subi    YL, lo8(-(usbRxBuf)) ;1 [08] 	[  rx]
    sbci    YH, hi8(-(usbRxBuf)) ;1 [09] 	[  rx]
    push    shift                ;2 [10+11]
    ser	    shift		 		;1 [12]
    sbis    USBIN, USBMINUS      ;1 [-1] [13] <--:   2  K [ 1   ]
    rjmp    haveTwoBitsK         ;2 [00] [14]
    pop     shift                ;2 	 [15+16]   push
    pop     YH 			         ;2 	 [17+18]   push
    rjmp    waitForK             ;2 	 [19+20]     sync,   
;    waitForK  rjmp waitForK       
;  (= 20 ).

;----------------------------------------------------------------------------
;     ,     :
;----------------------------------------------------------------------------
haveTwoBitsK:					;- [01]
    push    x1              	;2 [02+03]
    push    x2              	;2 [04+05]
    push    x3              	;2 [06+07]
    push    bitcnt				;2 [08+09]	
    in      x1, USBIN       	;1 [00] [10] <--   0
    bst     x1, USBMINUS    	;1 [01]
    bld     shift, 0        	;1 [02]
    push    cnt             	;2 [03+04]
    ldi     cnt, USB_BUFSIZE	;1 [05] 
    push    x4              	;2 [06+07]  tx
    rjmp    rxLoop          	;2 [08]
;----------------------------------------------------------------------------
;   (        )
;----------------------------------------------------------------------------
unstuff0:               	;- [07] ( )
    andi    x3, ~0x01   	;1 [08]
    mov     x1, x2      	;1 [09] X2    (stuffed) 
    in      x2, USBIN   	;1 [00] [10] <--   1 
    andi    x2, USBMASK 	;1 [01]
    breq    se0Hop         	;1 [02] SE0    1 
    ori     shift, 0x01 	;1 [03] 0b00000001
    nop				;1 [04]
    rjmp    didUnstuff0 	;2 [05]
;-----------------------------------------------------
unstuff1:               	;- [05] ( )
    mov     x2, x1      	;1 [06] x1    (stuffed) 
    andi    x3, ~0x02   	;1 [07]
    ori     shift, 0x02 	;1 [08] 0b00000010
    nop                 	;1 [09]
    in      x1, USBIN   	;1 [00] [10] <--   2 
    andi    x1, USBMASK 	;1 [01]
    breq    se0Hop         	;1 [02] SE0    2 
    rjmp    didUnstuff1 	;2 [03]
;-----------------------------------------------------
unstuff2:               	;- [05] ( )
    andi    x3, ~0x04   	;1 [06]
    ori     shift, 0x04 	;1 [07] 0b00000100
    mov     x1, x2      	;1 [08] x2    (stuffed) 
    nop                 	;1 [09]
    in      x2, USBIN   	;1 [00] [10] <--   3
    andi    x2, USBMASK 	;1 [01]
    breq    se0Hop         	;1 [02] SE0    3 
    rjmp    didUnstuff2 	;2 [03]
;-----------------------------------------------------
unstuff3:               	;- [00] [10] ( )
    in      x2, USBIN   	;1 [01] [11] <--  stuffed  3    
    andi    x2, USBMASK 	;1 [02]
    breq    se0Hop         	;1 [03] SE0   stuffed  3 
    andi    x3, ~0x08   	;1 [04]
    ori     shift, 0x08 	;1 [05] 0b00001000
    rjmp    didUnstuff3 	;2 [06]
;----------------------------------------------------------------------------
;  ,    :
;
; bit 0:    ,  [SE0   -    ], 
; 		 ,    rxLoop
; bit 1:     SE0
; bit 2:     SE0,    [  0    ]
; bit 3:     SE0,    [  0    ]
; bit 4:     SE0, 
; bit 5:     SE0, 
; bit 6:     SE0, 
; bit 7:     SE0, : x3 0   ,   , 1  
;----------------------------------------------------------------------------
rxLoop:						;- [09]
    in      x2, USBIN   	;1 [00] [10] <--   1 (  stuffed- 0)
    andi    x2, USBMASK 	;1 [01]
    brne    SkipSe0Hop		;1 [02]
se0Hop:						;- [02]
    rjmp    se0         	;2 [03] SE0    1 
SkipSe0Hop:					;- [03]
    ser     x3          	;1 [04]
    andi    shift, 0xf9 	;1 [05] 0b11111001
    breq    unstuff0    	;1 [06]
didUnstuff0:				;- [06]
    eor     x1, x2      	;1 [07]
    bst     x1, USBMINUS	;1 [08]
    bld     shift, 1    	;1 [09] 
    in      x1, USBIN   	;1 [00] [10] <--   2 (  stuffed- 1)
    andi    x1, USBMASK 	;1 [01]
    breq    se0Hop         	;1 [02] SE0    2 
    andi    shift, 0xf3 	;1 [03] 0b11110011
    breq    unstuff1    	;1 [04]      1
didUnstuff1:				;- [04]
    eor     x2, x1      	;1 [05]
    bst     x2, USBMINUS	;1 [06]
    bld     shift, 2    	;1 [07]
    nop2					;2 [08+09]
    in      x2, USBIN   	;1 [00] [10] <--   3 (  stuffed- 2)
    andi    x2, USBMASK 	;1 [01]
    breq    se0Hop         	;1 [02] SE0    3 
    andi    shift, 0xe7 	;1 [03] 0b11100111
    breq    unstuff2    	;1 [04]
didUnstuff2:				;- [04]
    eor     x1, x2      	;1 [05]
    bst     x1, USBMINUS	;1 [06]
    bld     shift, 3    	;1 [07]
didUnstuff3:				;- [07]
    andi    shift, 0xcf 	;1 [08] 0b11001111
    breq    unstuff3    	;1 [09]
    in      x1, USBIN   	;1 [00] [10] <--   4
    andi    x1, USBMASK 	;1 [01]
    breq    se0Hop         	;1 [02] SE0    4
    eor     x2, x1      	;1 [03]
    bst     x2, USBMINUS	;1 [04]
    bld     shift, 4    	;1 [05]
didUnstuff4:				;- [05]
    andi    shift, 0x9f 	;1 [06] 0b10011111
    breq    unstuff4    	;1 [07]
    nop2					;2 [08+09]
    in      x2, USBIN   	;1 [00] [10] <--   5
    andi    x2, USBMASK 	;1 [01]
    breq    se0         	;1 [02] SE0    5
    eor     x1, x2      	;1 [03]
    bst     x1, USBMINUS	;1 [04]
    bld     shift, 5    	;1 [05]
didUnstuff5:				;- [05]
    andi    shift, 0x3f 	;1 [06] 0b00111111
    breq    unstuff5    	;1 [07]
    nop2					;2 [08+09]
    in      x1, USBIN   	;1 [00] [10] <--   6
    andi    x1, USBMASK 	;1 [01]
    breq    se0         	;1 [02] SE0    6
    eor     x2, x1      	;1 [03]
    bst     x2, USBMINUS	;1 [04]
    bld     shift, 6   	 	;1 [05]
didUnstuff6:				;- [05]
    cpi     shift, 0x02 	;1 [06] 0b00000010
    brlo    unstuff6    	;1 [07]
    nop2					;2 [08+09]
    in      x2, USBIN   	;1 [00] [10] <--   7
    andi    x2, USBMASK 	;1 [01]
    breq    se0         	;1 [02] SE0    7
    eor     x1, x2      	;1 [03]
    bst     x1, USBMINUS	;1 [04]
    bld     shift, 7    	;1 [05]
didUnstuff7:				;- [05] 
    cpi     shift, 0x04 	;1 [06] 0b00000100
    brlo    unstuff7		;1 [07]
    eor     x3, shift   	;1 [08] : x3 0   ,   , 1  
    nop				;1 [09]
    in      x1, USBIN   	;1 [00]	[10] <--   0
    st      y+, x3      	;2 [01+02]  
    eor     x2, x1      	;1 [03]
    bst     x2, USBMINUS	;1 [04]
    bld     shift, 0    	;1 [05]
    subi    cnt, 1			;1 [06]
    brcs    overflow		;1 [07]
    rjmp    rxLoop			;2 [08]
;-----------------------------------------------------
unstuff4:               	;- [08] 
    andi    x3, ~0x10   	;1 [09]
    in      x1, USBIN   	;1 [00] [10] <--  stuffed  4
    andi    x1, USBMASK 	;1 [01]
    breq    se0         	;1 [02] SE0   stuffed  4
    ori     shift, 0x10 	;1 [03]
    rjmp    didUnstuff4 	;2 [04]
;-----------------------------------------------------
unstuff5:               	;- [08] 
    ori     shift, 0x20 	;1 [09]
    in      x2, USBIN   	;1 [00] [10] <--  stuffed  5
    andi    x2, USBMASK 	;1 [01]
    breq    se0         	;1 [02] SE0   stuffed  5
    andi    x3, ~0x20   	;1 [03]
    rjmp    didUnstuff5		;2 [04]
;-----------------------------------------------------
unstuff6:               	;- [08] 
    andi    x3, ~0x40   	;1 [09]
    in      x1, USBIN   	;1 [00] [10] <--  stuffed  6
    andi    x1, USBMASK 	;1 [01]
    breq    se0         	;1 [02] SE0   stuffed  6
    ori     shift, 0x40 	;1 [03]
    rjmp    didUnstuff6 	;2 [04]
;-----------------------------------------------------
unstuff7:			;- [08]
    andi    x3, ~0x80   	;1 [09]
    in      x2, USBIN   	;1 [00] [10] <--  stuffed  7
    andi    x2, USBMASK 	;1 [01]
    breq    se0         	;1 [02] SE0   stuffed  7
    ori     shift, 0x80 	;1 [03]
    rjmp    didUnstuff7 	;2 [04]
    
macro POP_STANDARD ; 16 
    pop     x4    
    pop     cnt
    pop     bitcnt
    pop     x3
    pop     x2
    pop     x1
    pop     shift
    pop     YH
endm
macro POP_RETI     ; 5 
    pop     YL
    out     SREG, YL
    pop     YL
endm

#include "asmcommon.inc"

;---------------------------------------------------------------------------
;  USB :
; idle = J
; J = (D+ = 0), (D- = 1)
; K = (D+ = 1), (D- = 0)
;   7.5   EOP  SOP  
;---------------------------------------------------------------------------
bitstuffN:		    	;- [04]
    eor     x1, x4 		;1 [05]
    clr	    x2			;1 [06]
    nop					;1 [07]
    rjmp    didStuffN   ;1 [08]
;---------------------------------------------------------------------------    
bitstuff6:		    	;- [04]
    eor     x1, x4      ;1 [05]
    clr	    x2			;1 [06]
    rjmp    didStuff6   ;1 [07]
;---------------------------------------------------------------------------
bitstuff7:		    	;- [02]
    eor     x1, x4      ;1 [03]
    clr	    x2			;1 [06]
    nop			    	;1 [05]
    rjmp    didStuff7   ;1 [06]
;---------------------------------------------------------------------------
sendNakAndReti:			;- [-19]
    ldi     x3, USBPID_NAK  	;1 [-18]
    rjmp    sendX3AndReti   	;1 [-17]
;---------------------------------------------------------------------------
sendAckAndReti:			;- [-17]
    ldi     cnt, USBPID_ACK 	;1 [-16]
sendCntAndReti:			;- [-16]
    mov     x3, cnt     ;1 [-15]
sendX3AndReti:			;- [-15]
    ldi     YL, 20      ;1 [-14] x3==r20   20
    ldi     YH, 0       ;1 [-13]
    ldi     cnt, 2      ;1 [-12]
;   rjmp    usbSendAndReti      
;---------------------------------------------------------------------------
;usbSend:
;   'Y'
;   'cnt' --   sync [ 2 ... 12]
;: x1...x4, btcnt, shift, cnt, Y
;       ,      (sync pattern) 
;      ,        
;  1.5%.
usbSendAndReti:             	;- [-13] 13     SOP
    in      x2, USBDDR      	;1 [-12]
    ori     x2, USBMASK     	;1 [-11]
    sbi     USBOUT, USBMINUS	;2 [-09-10]    (idle); D+  D-    0 (   (pullups))
    in      x1, USBOUT      	;1 [-08]      (tx)
    out     USBDDR, x2      	;1 [-07] <-  
	;    x2 ( bitstuff (  )),  sync   0
    ldi     x4, USBMASK     	;1 [-06] 	 exor ( )
    ldi     shift, 0x80     	;1 [-05] 	 sync -    
    ldi     bitcnt, 6    		;1 [-04] 
txBitLoop:		    			;- [-04] [06]
    sbrs    shift, 0        	;1 [-03] [07]
    eor     x1, x4          	;1 [-02] [08] 
    ror     shift           	;1 [-01] [09]  
didStuffN:		    			;-       [09]
    out     USBOUT, x1      	;1 [00]  [10] <--  N
    ror     x2              	;1 [01]
    cpi     x2, 0xfc        	;1 [02]
    brcc    bitstuffN       	;1 [03]
    dec     bitcnt          	;1 [04]
    brne    txBitLoop       	;1 [05]
    sbrs    shift, 0        	;1 [06]
    eor     x1, x4          	;1 [07]
    ror     shift           	;1 [08]
didStuff6:						;- [08]
    nop							;1 [09]
    out     USBOUT, x1      	;1 [00] [10] <--  6
    ror     x2              	;1 [01] 
    cpi     x2, 0xfc        	;1 [02]
    brcc    bitstuff6       	;1 [03]
    sbrs    shift, 0        	;1 [04]
    eor     x1, x4          	;1 [05]
    ror     shift           	;1 [06]
    ror     x2              	;1 [07]
didStuff7:						;- [07]
    ldi     bitcnt, 6    		;1 [08]
    cpi     x2, 0xfc        	;1 [09]
    out     USBOUT, x1      	;1 [00] [10] <--  7
    brcc    bitstuff7       	;1 [01]
    ld      shift, y+       	;2 [02+03]
    dec     cnt             	;1 [04]
    brne    txBitLoop      		;1 [05]
makeSE0:
    cbr     x1, USBMASK     	;1 [06] 	 SE0 [ ,  EOP    19  23 ]
    lds     x2, usbNewDeviceAddr;2 [07+08]
    lsl     x2                  ;1 [09]      
;2006-03-06:      usbDeviceAddr   C  :
;    ,    ,    (handshake)
    out     USBOUT, x1      	;1 [00] [10] <--  SE0--   2 bits==20       (idle)
    subi    YL, 20 + 2          ;1 [01]      ,  ACK/NAK  x3
    sbci    YH, 0           	;1 [02]
    breq    skipAddrAssign  	;1 [03]
    sts     usbDeviceAddr, x2	;2 [04+05]   : SE0    
;----------------------------------------------------------------------------
;  usbDeviceAddress
skipAddrAssign:						;- [03/04]
    ldi     x2, 1<<USB_INTR_PENDING_BIT	;1 [05] int0    TX --    
    USB_STORE_PENDING(x2)           ;1 [06]
    ori     x1, USBIDLE     		;1 [07]
    in      x2, USBDDR      		;1 [08]
    cbr     x2, USBMASK     		;1 [09]     
    mov     x3, x1          		;1 [10]
    cbr     x3, USBMASK     		;1 [11]     (pullup)   
    ldi     x4, 3           		;1 [12]
se0Delay:							;- [12] [15] 
    dec     x4              		;1 [13] [16] 
    brne    se0Delay        		;1 [14] [17] 
    nop2							;2      [18+19]
    out     USBOUT, x1      		;1      [20] <-- J (idle) --  SE0 ( EOP)
    out     USBDDR, x2      		;1      [21] <--  
    out     USBOUT, x3      		;1      [22] <--  ,     (pull-up) 
    rjmp    doReturn				;1	[23]
;---------------------------------------------------------------------------
