/* : usbdrvasm20.inc
 * :  AVR USB
 * : Jeroen Benschop
 *   usbdrvasm16.inc  Christian Starkjohann
 * : microsin.ru 
 *  : 2008-03-05
 * : 4
 * Copyright: (c) 2008 Jeroen Benschop  OBJECTIVE DEVELOPMENT Software GmbH
 * : GNU GPL v2 (. License.txt)   (CommercialLicense.txt)
 * : $Id: usbdrvasm20.inc 607 2008-05-13 15:57:28Z cs $
 */

/*    !    usbdrvasm.S,   include
 *      (   )!
 */

/*
 :
   16      USB.  
 16  (      RC-).

. usbdrv.h    .

       ,   ,  
  ,  !      
  CPU,     !
*/

#define leap2   x3
#ifdef __IAR_SYSTEMS_ASM__
#define nextInst    $+2
#else
#define nextInst    .+0
#endif

;  : [ret(2), YL, SREG, YH, bitcnt, shift, x1, x2, x3, x4, cnt] = 12 
; : 20  -> 13.333333   , 106.666667   
;      ,      sync
;   
;,    :
;   ,  
; x1    D+  D-
; x2    
; x4 (leap)          3  
; X3 (leap2)         3  stuff 
; bitcnt   ,    stuff 
; cnt       

USB_INTR_VECTOR:
;  : YL, SREG YH, [sofError], bitcnt, shift, x1, x2, x3, x4, cnt
    push    YL                  ;[-28] push    .   ASAP
    in      YL, SREG            ;[-26]
    push    YL                  ;[-25]
    push    YH                  ;[-23]
;----------------------------------------------------------------------------
;    sync:
;----------------------------------------------------------------------------
; sync- (D-)   (LSb)   (MSb) : 01010100 [1 =  (idle) = J, 0 = K]
;sync  J   K    sync --    
;    ,    IDLE  SE1 (== )
waitForJ:
    sbis    USBIN, USBMINUS     ;[-21] ,  D- == 1
    rjmp    waitForJ
waitForK:
;C      < 1/4 ,   .
    sbis    USBIN, USBMINUS     ;[-19]
    rjmp    foundK              ;[-18]
    sbis    USBIN, USBMINUS
    rjmp    foundK
    sbis    USBIN, USBMINUS
    rjmp    foundK
    sbis    USBIN, USBMINUS
    rjmp    foundK
    sbis    USBIN, USBMINUS
    rjmp    foundK
    sbis    USBIN, USBMINUS
    rjmp    foundK
    sbis    USBIN, USBMINUS
    rjmp    foundK
    sbis    USBIN, USBMINUS
    rjmp    foundK
    sbis    USBIN, USBMINUS
    rjmp    foundK
#if USB_COUNT_SOF
    lds     YL, usbSofCount
    inc     YL
    sts     usbSofCount, YL
#endif  /* USB_COUNT_SOF */
    rjmp    sofError
foundK:                         ;[-16]
;{3, 5}    D-  : 4 
; 0    34   .     4  30     0
;      setup,    . 
;   -     sync ( K)   
    push    bitcnt              ;[-16]
;   [---]                       ;[-15]
    lds     YL, usbInputBufOffset;[-14]
;   [---]                       ;[-13]
    clr     YH                  ;[-12]
    subi    YL, lo8(-(usbRxBuf));[-11] [  rx]
    sbci    YH, hi8(-(usbRxBuf));[-10] [  rx]
    push    shift               ;[-9]
;   [---]                       ;[-8]
    ldi     shift,0x40          ;[-7]  msb  "1" -      7
    nop2                        ;[-6]
;   [---]                       ;[-5]
    ldi     bitcnt, 5           ;[-4] [  rx]
    sbis    USBIN, USBMINUS     ;[-3]   2  K ( 3   )
    rjmp    haveTwoBitsK        ;[-2]
    pop     shift               ;[-1]   push
    pop     bitcnt              ;[1] 
    rjmp    waitForK            ;[3]     sync,   
;    waitForK  rjmp waitForK       
;  (= 27 ).

;----------------------------------------------------------------------------
;     ,     :
;----------------------------------------------------------------------------
haveTwoBitsK:
    push    x1                  ;[0]
    push    x2                  ;[2]
    push    x3                  ;[4] (leap2)
    ldi     leap2, 0x55         ;[6]  leap   2, 5, 8, ... stuff 
    push    x4                  ;[7] == leap
    ldi     leap, 0x55          ;[9]   leap  2, 5, 8, ...  
    push    cnt                 ;[10]
    ldi     cnt, USB_BUFSIZE    ;[12] [  rx]
    ldi     x2, 1<<USBPLUS      ;[13]    -  K. D+=="1", D-=="0"
bit0:       
    in      x1, USBIN           ;[0]   
    andi    x1, USBMASK         ;[1]    D+  D-
    rjmp    handleBit           ;[2]  bit 0  14 

;----------------------------------------------------------------------------
;   7. ,  6     (unstuffing).
;----------------------------------------------------------------------------

b6checkUnstuff:
    dec     bitcnt              ;[9]
    breq    unstuff6            ;[10]
bit7:
    subi    cnt, 1              ;[11]     dec,        (carry)
    brcs    overflow            ;[12]    .  
    in      x1, USBIN           ;[0]   
    andi    x1, USBMASK         ;[1]    D+  D-
    cpse    x1, x2              ;[2]      ,  "1"
    rjmp    b7handle0           ;[3]    ,  "0"
    sec                         ;[4]
    ror     shift               ;[5]  "1"  
    st      y+, shift           ;[6]    
    ldi     shift, 0x40         ;[7]      
    subi    leap, 0x55          ;[9]     3 
    brcc    nextInst            ;[10  11]     85 .      (low speed)    11
    dec     bitcnt              ;[11  12]
    brne    bit0                ;[12  13]
    ldi     x1, 1               ;[13  14] unstuffing  7
    in      bitcnt, USBIN       ;[0]  stuff-
    rjmp    unstuff             ;[1]

b7handle0:
    mov     x2,x1               ;[5]  x2    
    ldi     bitcnt, 6           ;[6]
    lsr     shift               ;[7]  "0"  
    st      y+, shift           ;[8]    
    ldi     shift, 0x40         ;[10]      
    subi    leap, 0x55          ;[11]     3 
    brcs    bit0                ;[12]     85 .      (low speed)    11
    rjmp    bit0                ;[13]


;----------------------------------------------------------------------------
;  unstuff
; x1==0xFF  unstuffing  6
;----------------------------------------------------------------------------

unstuff6:
    ldi     x1,0xFF             ;[12]  unstuffing  6
    in      bitcnt, USBIN       ;[0]   stuff 
    nop                         ;[1]   
unstuff:                        ;b0-5  b6   b7
    mov     x2,bitcnt           ;[3]  [2]  [3]   x2     
    subi    leap2, 0x55         ;[4]  [3]  [4]   
    brcs    nextInst            ;[5]  [4]  [5]      3 stuff 
    sbci    leap2,0             ;[6]  [5]  [6]
    ldi     bitcnt,6            ;[7]  [6]  [7]    stuff 
    andi    x2, USBMASK         ;[8]  [7]  [8]   D+  D-
    cpi     x1,0                ;[9]  [8]  [9]
    brmi    bit7                ;[10] [9]  [10]  unstuffing  6    x1<0
    breq    bitloop             ;[11] ---  [11]  unstuffing   0-5  x1=0
    nop                         ;---  ---  [12]
    in      x1, USBIN           ;---  ---  [0]      0
    andi    x1, USBMASK         ;---  ---  [1]   D+  D- 
    rjmp    handleBit           ;---  ---  [2]   0  14 

;----------------------------------------------------------------------------
;   (        )
;----------------------------------------------------------------------------
bitloop:
    in      x1, USBIN           ;[0]   
    andi    x1, USBMASK         ;[1]    D+  D-
    breq    se0                 ;[2]     low   se0
handleBit:
    cpse    x1, x2              ;[3]      ,  "1"
    rjmp    handle0             ;[4]    ,  "0"
    sec                         ;[5]
    ror     shift               ;[6]  "1"  
    brcs    b6checkUnstuff      ;[7]      C ,   -  7
    nop2                        ;[8]
    dec     bitcnt              ;[10]
    brne    bitloop             ;[11]
    ldi     x1,0                ;[12]  unstuff  ,    6  7
    in      bitcnt, USBIN       ;[0]  stuff 
    rjmp    unstuff             ;[1]

handle0:
    mov     x2, x1              ;[6]  x2    
    ldi     bitcnt, 6           ;[7]   unstuff. 
    lsr     shift               ;[8]  "0"  
    brcs    bit7                ;[9]      C ,   -  7
    nop                         ;[10]
    rjmp    bitloop             ;[11] 
    
;----------------------------------------------------------------------------
;   .    EOP
;----------------------------------------------------------------------------

macro POP_STANDARD ; 14 
    pop     cnt
    pop     x4
    pop     x3
    pop     x2
    pop     x1
    pop     shift
    pop     bitcnt
endm
macro POP_RETI     ; 7 
    pop     YH
    pop     YL
    out     SREG, YL
    pop     YL
endm



#include "asmcommon.inc"

;  USB :
; idle = J
; J = (D+ = 0), (D- = 1)
; K = (D+ = 1), (D- = 0)
;   7.5   EOP  SOP  
; 7.5     100 .      se0,
;     ,    

bitstuffN:
    eor     x1, x4          ;[8]
    ldi     x2, 0           ;[9]
    nop2                    ;[10]
    out     USBOUT, x1      ;[12] <-- 
    rjmp    didStuffN       ;[0]
    
bitstuff7:
    eor     x1, x4          ;[6]
    ldi     x2, 0           ;[7] Carry      brcc
    rol     shift           ;[8]   ror   
    nop2                    ;[9]
    rjmp    didStuff7       ;[11]

sendNakAndReti:
    ldi     x3, USBPID_NAK  ;[-18]
    rjmp    sendX3AndReti   ;[-17]
sendAckAndReti:
    ldi     cnt, USBPID_ACK ;[-17]
sendCntAndReti:
    mov     x3, cnt         ;[-16]
sendX3AndReti:
    ldi     YL, 20          ;[-15] x3==r20   20
    ldi     YH, 0           ;[-14]
    ldi     cnt, 2          ;[-13]
;   rjmp    usbSendAndReti      

;usbSend:
;    'Y'
;   'cnt' --   sync [ 2 ... 12]
;: x1...x4, btcnt, shift, cnt, Y
;       ,      (sync pattern) 
;      ,        
;  1.5%.
usbSendAndReti:             ; 12     SOP
    in      x2, USBDDR      ;[-12]
    ori     x2, USBMASK     ;[-11]
    sbi     USBOUT, USBMINUS;[-10]    (idle); D+  D-    0 (   (pullups))
    in      x1, USBOUT      ;[-8]      (tx)
    out     USBDDR, x2      ;[-7] <-  
;    x2 ( bitstuff (  )),  sync   0
    ldi     x4, USBMASK     ;[-6]  exor ( )
    ldi     shift, 0x80     ;[-5]  sync -    
txByteLoop:
    ldi     bitcnt, 0x49    ;[-4]        [10]  01001001
txBitLoop:
    sbrs    shift, 0        ;[-3] [10]   [11]
    eor     x1, x4          ;[-2] [11]   [12]
    out     USBOUT, x1      ;[-1] [12]   [13]   <--  N
    ror     shift           ;[0]  [13]   [14]
    ror     x2              ;[1]
didStuffN:
    nop2                    ;[2]
    nop                     ;[4]
    cpi     x2, 0xfc        ;[5]
    brcc    bitstuffN       ;[6]
    lsr     bitcnt          ;[7]
    brcc    txBitLoop       ;[8]
    brne    txBitLoop       ;[9]

    sbrs    shift, 0        ;[10]
    eor     x1, x4          ;[11]
didStuff7:
    out     USBOUT, x1      ;[-1] [13] <--  7
    ror     shift           ;[0] [14]
    ror     x2              ;[1]
    nop                     ;[2]
    cpi     x2, 0xfc        ;[3]
    brcc    bitstuff7       ;[4]
    ld      shift, y+       ;[5]
    dec     cnt             ;[7]
    brne    txByteLoop      ;[8]
;make SE0:
    cbr     x1, USBMASK     ;[9]  SE0 [ ,  EOP    25  30 ]
    lds     x2, usbNewDeviceAddr;[10]
    lsl     x2              ;[12]      
    out     USBOUT, x1      ;[13] <--  SE0 --   2  = 22      (idle)
    subi    YL, 20 + 2      ;[0]      ,  ACK/NAK  x3
    sbci    YH, 0           ;[1]
;2006-03-06:      usbDeviceAddr   C  :
;    ,    ,    (handshake)
    breq    skipAddrAssign  ;[2]
    sts     usbDeviceAddr, x2;   : SE0    
skipAddrAssign:
;  usbDeviceAddress
    ldi     x2, 1<<USB_INTR_PENDING_BIT;[4] int0    TX --    
    USB_STORE_PENDING(x2)   ;[5]
    ori     x1, USBIDLE     ;[6]
    in      x2, USBDDR      ;[7]
    cbr     x2, USBMASK     ;[8]     
    mov     x3, x1          ;[9]
    cbr     x3, USBMASK     ;[10]     (pullup)   
    ldi     x4, 5           ;[11]
se0Delay:
    dec     x4              ;[12] [15] [18] [21] [24]
    brne    se0Delay        ;[13] [16] [19] [22] [25]
    out     USBOUT, x1      ;[26] <--  J (idle) --  SE0 ( EOP)
    out     USBDDR, x2      ;[27] <--   
    out     USBOUT, x3      ;[28] <--   ,     (pull-up) 
    rjmp    doReturn
